// MyPCIc.h
//
// Generated by C DriverWizard 3.2.0 (Build 2485)
// Requires DDK Only
// File created on 1/30/2010
//
#ifndef __MYPCIC_H__
#define __MYPCIC_H__

// Memory allocation pool tag
#define MYPCIC_POOL_TAG 'CPyM'

// Make all pool allocations tagged
#undef ExAllocatePool
#define ExAllocatePool(type, size) \
    ExAllocatePoolWithTag(type, size, MYPCIC_POOL_TAG);

// queue start io callback
typedef VOID (*PMYPCIC_QUEUE_STARTIO)(
    IN PDEVICE_OBJECT   DeviceObject,
    IN PIRP             Irp 
    );

// irp queue type definition
typedef struct _MYPCIC_QUEUE
{
    PMYPCIC_QUEUE_STARTIO StartIoRoutine;
    PDEVICE_OBJECT  DeviceObject;
    LIST_ENTRY      IrpQueue;
    KSPIN_LOCK      QueueLock;
    PIRP            CurrentIrp;
    KEVENT          StopEvent;
    LONG            StallCount; 
    NTSTATUS        ErrorStatus;
    KDPC            MyPCIcStartIoDpc;
    BOOLEAN         bUseMyPCIcStartIoDpc;
} MYPCIC_QUEUE, *PMYPCIC_QUEUE;

// cancel-safe irp list type definition
typedef struct _MYPCIC_LIST
{
    PDEVICE_OBJECT  DeviceObject;
    LIST_ENTRY      IrpList;
    KSPIN_LOCK      ListLock;
    NTSTATUS        ErrorStatus;
} MYPCIC_LIST, *PMYPCIC_LIST;

// stall IRP list to syncronize Pnp, Power with
// the rest of IO
typedef struct _MYPCIC_IO_LOCK
{
    PDEVICE_OBJECT  DeviceObject;       // our device object
    KEVENT          StallCompleteEvent; // io stalled event
    LIST_ENTRY      StallIrpList;       // stalled irps
    KSPIN_LOCK      IoLock;             // spin lock to syncronize io with stall/unstall
    LONG            StallCount;         // number of times stall was requested
    LONG            ActiveIrpCount;     // number of oustanding, not-stalled IRPs
    NTSTATUS        ErrorStatus;
    PIRP            CurrentIrp;         // used by unstall code
} MYPCIC_IO_LOCK, *PMYPCIC_IO_LOCK;

// global (per driver) data block
typedef struct _MYPCIC_DATA
{
    UNICODE_STRING      RegistryPath;           // saved registry path
    ULONG               InstanceCount;          // FDO instance count
    USHORT              WdmVersion;             // os version
} MYPCIC_DATA, *PMYPCIC_DATA;

extern MYPCIC_DATA g_Data;

// PnP states
typedef enum _MYPCIC_PNP_STATE 
{
    PnpStateNotStarted = 0,
    PnpStateStarted,
    PnpStateStopPending,
    PnpStateStopped,
    PnpStateRemovePending,
    PnpStateRemoved,
    PnpStateSurpriseRemoved
} MYPCIC_PNP_STATE;


// The device extension for the device object
typedef struct _MYPCIC_DEVICE_EXTENSION
{
    PDEVICE_OBJECT          DeviceObject;           // pointer to the DeviceObject
    PDEVICE_OBJECT          PhysicalDeviceObject;   // underlying PDO
    PDEVICE_OBJECT          LowerDeviceObject;      // top of the device stack

    LONG                    RemoveCount;            // 1-based reference count
    KEVENT                  RemoveEvent;            // event to sync device removal

    MYPCIC_IO_LOCK IoLock;                 // misc io lock

    MYPCIC_PNP_STATE    PnpState;               // PnP state variable
    MYPCIC_PNP_STATE    PreviousPnpState;       // Previous PnP state variable

    UNICODE_STRING          InterfaceName;          // name returned from IoRegisterDeviceInterface

    SYSTEM_POWER_STATE      SystemPowerState;       // current system power state
    DEVICE_POWER_STATE      DevicePowerState;       // current device power state
    DEVICE_CAPABILITIES     DeviceCaps;             // device capabilities used to get S to D mappings
    PIRP                    SystemPowerIrp;         // Storage for system IRP during power transitions
    PIRP                    DevicePowerIrp;         // Storage for device IRP during power transitions
    PIO_WORKITEM            PowerWorkItem;          // Work item used for power transitions
    LONG                    bPowerStop;             // Flag to signal that power code stopped io
    LONG                    OpenHandleCount;

    PUCHAR                  Resource2Base;            // Memory resource pointer
    ULONG                   Resource2Length;          // Memory resource length
    BOOLEAN                 bResource2Mapped;         // Memory resource mapped flag
    BOOLEAN                 bResource2IsIo;           // if TRUE, use PORT functions, otherwise use REGISTER

    PUCHAR                  Resource0Base;              // Port resource pointer
    ULONG                   Resource0Length;            // Port resource length
    BOOLEAN                 bResource0Mapped;           // Port resource mapped flag
    BOOLEAN                 bResource0IsIo;             // if TRUE, use PORT functions, otherwise use REGISTER

    PUCHAR                  Resource1Base;              // Port resource pointer
    ULONG                   Resource1Length;            // Port resource length
    BOOLEAN                 bResource1Mapped;           // Port resource mapped flag
    BOOLEAN                 bResource1IsIo;             // if TRUE, use PORT functions, otherwise use REGISTER
} MYPCIC_DEVICE_EXTENSION, *PMYPCIC_DEVICE_EXTENSION;

#ifdef __cplusplus
extern "C" 
{
#endif

NTSTATUS __stdcall DriverEntry(
    IN  PDRIVER_OBJECT  DriverObject,
    IN  PUNICODE_STRING RegistryPath
    );

NTSTATUS __stdcall MyPCIcAddDevice(
    IN  PDRIVER_OBJECT  DriverObject,
    IN  PDEVICE_OBJECT  PhysicalDeviceObject
    );

VOID __stdcall MyPCIcUnload(
    IN  PDRIVER_OBJECT  DriverObject
    );

NTSTATUS __stdcall MyPCIcPnpDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS __stdcall MyPCIcPowerDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS __stdcall MyPCIcDeviceIoControlDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS __stdcall MyPCIcCreateDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS __stdcall MyPCIcCloseDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS __stdcall MyPCIcReadDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS __stdcall MyPCIcWriteDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS __stdcall MyPCIcCleanupDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS __stdcall MyPCIcSystemControlDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

///////////////////////////////////////////////////////////////////////////////////////////////////
// Queue Functions
///////////////////////////////////////////////////////////////////////////////////////////////////

VOID MyPCIcInitializeQueue(
    IN  PMYPCIC_QUEUE    QueueExtension,
    IN  PMYPCIC_QUEUE_STARTIO     StartIoRoutine,
    IN  PDEVICE_OBJECT      DeviceObject,
    IN  BOOLEAN             bUseMyPCIcStartIoDpc
    );

NTSTATUS MyPCIcQueueIrp(
    IN  PMYPCIC_QUEUE    QueueExtension,
    IN  PIRP                Irp
    );

VOID MyPCIcStartNext(
    IN  PMYPCIC_QUEUE    QueueExtension
    );

VOID MyPCIcFlushQueue(
    IN  PMYPCIC_QUEUE    QueueExtension,
    IN  PFILE_OBJECT        FileObject
    );

VOID MyPCIcInvalidateQueue(
    IN  PMYPCIC_QUEUE    Queue,
    IN  NTSTATUS                  ErrorStatus
    );

VOID MyPCIcPauseQueue(
    IN  PMYPCIC_QUEUE    QueueExtension
    );
    
VOID MyPCIcRestartQueue(
    IN  PMYPCIC_QUEUE    QueueExtension
    );

VOID MyPCIcStartIoDpc(
    IN  PKDPC       Dpc,
    IN  PVOID       Context,
    IN  PVOID       Unused1,
    IN  PVOID       Unused2
    );

VOID MyPCIcQueueCancelRoutine(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

///////////////////////////////////////////////////////////////////////////////////////////////////
// List functions
///////////////////////////////////////////////////////////////////////////////////////////////////

VOID MyPCIcInitializeList(
    IN  PMYPCIC_LIST   List,
    IN  PDEVICE_OBJECT          DeviceObject
    );

NTSTATUS MyPCIcInsertHead(
    IN  PMYPCIC_LIST   List, 
    IN  PIRP                Irp
    );

NTSTATUS MyPCIcInsertTail(
    IN  PMYPCIC_LIST   List, 
    IN  PIRP                Irp
    );

PIRP MyPCIcRemoveHead(
    IN  PMYPCIC_LIST   List
    );

PIRP MyPCIcRemoveTail(
    IN  PMYPCIC_LIST   List
    );

VOID MyPCIcFlushList(
    IN  PMYPCIC_LIST   List,
    IN  PFILE_OBJECT        FileObject
    );

VOID MyPCIcInvalidateList(
    IN  PMYPCIC_LIST   List,
    IN  NTSTATUS                ErrorStatus
    );

VOID MyPCIcListCancelRoutine(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

///////////////////////////////////////////////////////////////////////////////////////////////////
// MYPCIC_IO_LOCK
///////////////////////////////////////////////////////////////////////////////////////////////////

VOID MyPCIcInitializeIoLock(
    IN  PMYPCIC_IO_LOCK    IoLock, 
    IN  PDEVICE_OBJECT              DeviceObject
    );

NTSTATUS MyPCIcCheckIoLock(
    IN  PMYPCIC_IO_LOCK    IoLock, 
    IN  PIRP                        Irp
    );

VOID MyPCIcPendingIoCancelRoutine(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS MyPCIcIncrementIoCount(
    IN  PMYPCIC_IO_LOCK    IoLock
    );

VOID MyPCIcDecrementIoCount(
    IN  PMYPCIC_IO_LOCK    IoLock
    );

VOID MyPCIcLockIo(
    IN  PMYPCIC_IO_LOCK    IoLock
    );

VOID MyPCIcWaitForStopIo(
    IN  PMYPCIC_IO_LOCK    IoLock
    );

VOID MyPCIcUnlockIo(
    IN  PMYPCIC_IO_LOCK    IoLock
    );

VOID MyPCIcFlushPendingIo(
    IN  PMYPCIC_IO_LOCK    IoLock,
    IN  PFILE_OBJECT                FileObject
    );

VOID MyPCIcInvalidateIo(
    IN  PMYPCIC_IO_LOCK    IoLock,
    IN  NTSTATUS                    ErrorStatus
    );
#ifdef __cplusplus
}
#endif

BOOLEAN MyPCIcIsStoppable(
    IN  PMYPCIC_DEVICE_EXTENSION    DeviceExtension
    );

BOOLEAN MyPCIcIsRemovable(
    IN  PMYPCIC_DEVICE_EXTENSION    DeviceExtension
    );

BOOLEAN MyPCIcAcquireRemoveLock(
    IN  PMYPCIC_DEVICE_EXTENSION    DeviceExtension
    );

VOID MyPCIcReleaseRemoveLock(
    IN  PMYPCIC_DEVICE_EXTENSION    DeviceExtension
    );

VOID MyPCIcWaitForSafeRemove(
    IN  PMYPCIC_DEVICE_EXTENSION    DeviceExtension
    );

NTSTATUS MyPCIcSubmitIrpSync(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

VOID MyPCIcStallQueues(
    IN  PMYPCIC_DEVICE_EXTENSION DeviceExtension
    );

VOID MyPCIcRestartQueues(
    IN  PMYPCIC_DEVICE_EXTENSION DeviceExtension
    );

VOID MyPCIcFlushQueues(
    IN  PMYPCIC_DEVICE_EXTENSION   DeviceExtension,
    IN  PFILE_OBJECT            FileObject
    );

///////////////////////////////////////////////////////////////////////////////////////////////////
// Pnp 
///////////////////////////////////////////////////////////////////////////////////////////////////

// define this PnP IRP.  This IRP is only defined in ntddk.h normally
#if !defined(IRP_MN_QUERY_LEGACY_BUS_INFORMATION)
#define IRP_MN_QUERY_LEGACY_BUS_INFORMATION     0x18
#endif // IRP_MN_QUERY_LEGACY_BUS_INFORMATION

NTSTATUS MyPCIcStartDevice(
    IN  PMYPCIC_DEVICE_EXTENSION    DeviceExtension,
    IN  PIRP                            Irp
    );

NTSTATUS MyPCIcFreeResources(
    IN  PMYPCIC_DEVICE_EXTENSION DeviceExtension
    );

NTSTATUS MyPCIcGetDeviceCapabilities(
    IN  PMYPCIC_DEVICE_EXTENSION    DeviceExtension
    );

///////////////////////////////////////////////////////////////////////////////////////////////////
// Power
///////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _MYPCIC_POWER_IRP_CONTEXT
{
    PKEVENT         Event;
    NTSTATUS        Status;
} MYPCIC_POWER_IRP_CONTEXT, *PMYPCIC_POWER_IRP_CONTEXT;


#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

NTSTATUS MyPCIcSystemPowerDispatch(
    IN  PMYPCIC_DEVICE_EXTENSION        DeviceExtension,
    IN  PIRP                        Irp
    );

NTSTATUS MyPCIcSystemPowerCompletionRoutine(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp,
    IN  PVOID           Context
    );

NTSTATUS MyPCIcDeviceQueryPowerCompletionRoutine(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp,
    IN  PVOID           Context
    );

NTSTATUS MyPCIcDeviceSetPowerCompletionRoutine(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp,
    IN  PVOID           Context
    );

VOID MyPCIcDevicePowerCompleteCallback(
    IN  PDEVICE_OBJECT      DeviceObject,
    IN  UCHAR               MinorFunction,
    IN  POWER_STATE         PowerState,
    IN  PVOID               Context,
    IN  PIO_STATUS_BLOCK    IoStatus
    );

#ifdef __cplusplus
}
#endif // __cplusplus

NTSTATUS MyPCIcGetDevicePowerState(
    IN  PMYPCIC_DEVICE_EXTENSION        DeviceExtension,
    IN  SYSTEM_POWER_STATE              SystemState,
    OUT PDEVICE_POWER_STATE             DeviceState
    );

VOID MyPCIcPowerDownPreparation(
    IN  PMYPCIC_DEVICE_EXTENSION        DeviceExtension,
    IN  PIO_WORKITEM_ROUTINE                Callback
    );

VOID MyPCIcPowerDownPrepCallback(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PVOID           Context
    );

VOID MyPCIcPowerD0PrepCallback(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PVOID           Context
    );

VOID MyPCIcPowerUpCallback(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PVOID           Context
    );

VOID MyPCIcRequestDevicePowerIrpCallback(
    IN  PDEVICE_OBJECT      DeviceObject,
    IN  UCHAR               MinorFunction,
    IN  POWER_STATE         PowerState,
    IN  PVOID               Context,
    IN  PIO_STATUS_BLOCK    IoStatus
    );

NTSTATUS MyPCIcRequestDevicePowerIrp(
    IN  PMYPCIC_DEVICE_EXTENSION        DeviceExtension,
    IN  DEVICE_POWER_STATE             DeviceState
    );


///////////////////////////////////////////////////////////////////////////////////////////////////
// Registry
///////////////////////////////////////////////////////////////////////////////////////////////////

PVOID MyPCIcRegQueryValueKey(
    IN  HANDLE  RegKeyHandle,
    IN  PWSTR   SubKeyName,
    IN  PWSTR   ValueName,
    OUT PULONG  Length
    );

VOID MyPCIcRegEnumerateKeys(
    IN  HANDLE RegKeyHandle
    );

VOID MyPCIcRegEnumerateValueKeys(
    IN  HANDLE  RegKeyHandle
    );

///////////////////////////////////////////////////////////////////////////////////////////////////
// Debug
///////////////////////////////////////////////////////////////////////////////////////////////////

// definition of debug levels

#define DBG_NONE            0
#define DBG_ERR             1
#define DBG_WARN            2
#define DBG_TRACE           3
#define DBG_INFO            4
#define DBG_VERB            5

#ifdef MYPCIC_WMI_TRACE

/*
tracepdb -f objchk_wxp_x86\i386\MyPCIc.pdb -p C:\MyPCIc
SET TRACE_FORMAT_SEARCH_PATH=C:\MyPCIc

tracelog -start MyPCIc -guid MyPCIc.ctl -f MyPCIc.log -flags 0x7FFFFFFF -level 5
tracelog -stop MyPCIc

tracefmt -o MyPCIc.txt -f MyPCIc.log
*/

#define WPP_AREA_LEVEL_LOGGER(Area,Lvl)           WPP_LEVEL_LOGGER(Area)
#define WPP_AREA_LEVEL_ENABLED(Area,Lvl)          (WPP_LEVEL_ENABLED(Area) && WPP_CONTROL(WPP_BIT_##Area).Level >= Lvl)

#define WPP_CONTROL_GUIDS \
    WPP_DEFINE_CONTROL_GUID(MyPCIc,(40D3FC6C,EC5B,4A08,BCE1,A37870D1D906), \
        WPP_DEFINE_BIT(DBG_GENERAL)                 /* bit  0 = 0x00000001 */ \
        WPP_DEFINE_BIT(DBG_PNP)                     /* bit  1 = 0x00000002 */ \
        WPP_DEFINE_BIT(DBG_POWER)                   /* bit  2 = 0x00000004 */ \
        WPP_DEFINE_BIT(DBG_COUNT)                   /* bit  3 = 0x00000008 */ \
        WPP_DEFINE_BIT(DBG_CREATECLOSE)             /* bit  4 = 0x00000010 */ \
        WPP_DEFINE_BIT(DBG_WMI)                     /* bit  5 = 0x00000020 */ \
        WPP_DEFINE_BIT(DBG_UNLOAD)                  /* bit  6 = 0x00000040 */ \
        WPP_DEFINE_BIT(DBG_IO)                      /* bit  7 = 0x00000080 */ \
        WPP_DEFINE_BIT(DBG_INIT)                    /* bit  8 = 0x00000100 */ \
        WPP_DEFINE_BIT(DBG_09)                      /* bit  9 = 0x00000200 */ \
        WPP_DEFINE_BIT(DBG_10)                      /* bit 10 = 0x00000400 */ \
        WPP_DEFINE_BIT(DBG_11)                      /* bit 11 = 0x00000800 */ \
        WPP_DEFINE_BIT(DBG_12)                      /* bit 12 = 0x00001000 */ \
        WPP_DEFINE_BIT(DBG_13)                      /* bit 13 = 0x00002000 */ \
        WPP_DEFINE_BIT(DBG_14)                      /* bit 14 = 0x00004000 */ \
        WPP_DEFINE_BIT(DBG_15)                      /* bit 15 = 0x00008000 */ \
        WPP_DEFINE_BIT(DBG_16)                      /* bit 16 = 0x00010000 */ \
        WPP_DEFINE_BIT(DBG_17)                      /* bit 17 = 0x00020000 */ \
        WPP_DEFINE_BIT(DBG_18)                      /* bit 18 = 0x00040000 */ \
        WPP_DEFINE_BIT(DBG_19)                      /* bit 19 = 0x00080000 */ \
        WPP_DEFINE_BIT(DBG_20)                      /* bit 20 = 0x00100000 */ \
        WPP_DEFINE_BIT(DBG_21)                      /* bit 21 = 0x00200000 */ \
        WPP_DEFINE_BIT(DBG_22)                      /* bit 22 = 0x00400000 */ \
        WPP_DEFINE_BIT(DBG_23)                      /* bit 23 = 0x00800000 */ \
        WPP_DEFINE_BIT(DBG_24)                      /* bit 24 = 0x01000000 */ \
        WPP_DEFINE_BIT(DBG_25)                      /* bit 25 = 0x02000000 */ \
        WPP_DEFINE_BIT(DBG_26)                      /* bit 26 = 0x04000000 */ \
        WPP_DEFINE_BIT(DBG_27)                      /* bit 27 = 0x08000000 */ \
        WPP_DEFINE_BIT(DBG_28)                      /* bit 28 = 0x10000000 */ \
        WPP_DEFINE_BIT(DBG_29)                      /* bit 29 = 0x20000000 */ \
        WPP_DEFINE_BIT(DBG_30)                      /* bit 30 = 0x40000000 */ \
        WPP_DEFINE_BIT(DBG_31)                      /* bit 31 = 0x80000000 */ \
        )

__inline VOID MyPCIcDumpIrp(
    IN PIRP Irp
    )
{
}

__inline PCHAR SystemPowerStateString(
    IN  SYSTEM_POWER_STATE  SystemState
    )
{
    return "";
}

__inline PCHAR DevicePowerStateString(
    IN  DEVICE_POWER_STATE  DeviceState
    )
{
    return "";
}

#else

// definition of debug areas

#define DBG_GENERAL         (1 << 0)
#define DBG_PNP             (1 << 1)
#define DBG_POWER           (1 << 2)
#define DBG_COUNT           (1 << 3)
#define DBG_CREATECLOSE     (1 << 4)
#define DBG_WMI             (1 << 5)
#define DBG_UNLOAD          (1 << 6)
#define DBG_IO              (1 << 7)
#define DBG_INIT            (1 << 8)

#define DBG_ALL             0xFFFFFFFF

#if DBG

VOID MyPCIcDebugPrint(
    IN ULONG    Area,
    IN ULONG    Level,
    IN PCCHAR   Format,
    IN          ...
    );

VOID MyPCIcDumpIrp(
    IN PIRP Irp
    );

PCHAR IrpMajorFunctionString(
    IN  UCHAR MajorFunction
    );

PCHAR PnPMinorFunctionString(
    IN  UCHAR   MinorFunction
    );

PCHAR PowerMinorFunctionString(
    IN  UCHAR   MinorFunction
    );

PCHAR SystemPowerStateString(
    IN  SYSTEM_POWER_STATE  SystemState
    );

PCHAR DevicePowerStateString(
    IN  DEVICE_POWER_STATE  DeviceState
    );

PCHAR WMIMinorFunctionString (
    IN  UCHAR MinorFunction
    );

#else	// !DBG

__inline VOID MyPCIcDebugPrint(
    IN ULONG    Area,
    IN ULONG    Level,
    IN PCCHAR   Format,
    IN          ...
    )
{
}

#define MyPCIcDumpIrp(Irp)
#define IrpMajorFunctionString(MajorFunction)
#define PnPMinorFunctionString(MinorFunction)
#define PowerMinorFunctionString(MinorFunction)
#define SystemPowerStateString(SystemState) 0
#define DevicePowerStateString(DeviceState) 0
#define WMIMinorFunctionString(MinorFunction)
#define MyPCIcTdiDumpAddress(Address)

#endif	// DBG
#endif	// MYPCIC_WMI_TRACE

NTSTATUS MyPCIcAccessConfigSpace(
    IN  PMYPCIC_DEVICE_EXTENSION DeviceExtension,
    IN  BOOLEAN                 IsRead,
    IN OUT PVOID                Buffer,
    IN  ULONG                   Offset,
    IN  ULONG                   Length,
    OUT PULONG                  ReadWrittenSize
    );

#endif  // __MYPCIC_H__
