// wmi.c
//
// Generated by C DriverWizard 3.2.0 (Build 2485)
// Requires DDK Only
// File created on 1/30/2010
//

#include "pch.h"
#ifdef MYPCIC_WMI_TRACE
#include "wmi.tmh"
#endif


///////////////////////////////////////////////////////////////////////////////////////////////////
//  MyPCIcSystemControlDispatch
//      Dispatch routine for IRP_MJ_SYSTEM_CONTROL requests.
//
//  Arguments:
//      IN  DeviceObject
//              pointer to the device object for our device
//
//      IN  Irp
//              the IRP_MJ_SYSTEM_CONTROL IRP
//
//  Return Value:
//      NT status code.
//
NTSTATUS MyPCIcSystemControlDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    )
{
    PMYPCIC_DEVICE_EXTENSION    deviceExtension;
    NTSTATUS                        status;
    PIO_STACK_LOCATION              stack;

    MyPCIcDebugPrint(DBG_WMI, DBG_TRACE, __FUNCTION__"++. IRP %p", Irp);

    MyPCIcDumpIrp(Irp);

    deviceExtension = (PMYPCIC_DEVICE_EXTENSION)DeviceObject->DeviceExtension;

    // protect againt IRP_MN_REMOVE_DEVICE
    if (!MyPCIcAcquireRemoveLock(deviceExtension))
    {
        status = STATUS_DELETE_PENDING;

        Irp->IoStatus.Status = status;
        IoCompleteRequest (Irp, IO_NO_INCREMENT);

        MyPCIcDebugPrint(DBG_WMI, DBG_WARN, __FUNCTION__"--. IRP %p, STATUS %x", Irp, status);

        return status;
    }

    // just pass it through
    IoSkipCurrentIrpStackLocation(Irp);
    status = IoCallDriver(deviceExtension->LowerDeviceObject, Irp);

    MyPCIcReleaseRemoveLock(deviceExtension);

    MyPCIcDebugPrint(DBG_WMI, DBG_TRACE, __FUNCTION__"--. IRP %p, STATUS %x", Irp, status);

    return status;
}
